DROP PROCEDURE IF EXISTS dbo.sp_cleanfrlloprocess;
DROP PROCEDURE IF EXISTS public.sp_cleanfrlloprocess;
DROP PROCEDURE IF EXISTS rds.sp_cleanfrlloprocess;

CREATE OR REPLACE PROCEDURE rds.sp_cleanfrlloprocess(
    "ExportId" uuid DEFAULT NULL
)
    LANGUAGE plpgsql
AS
$$
DECLARE
    p_exportid uuid := "ExportId";
    v_num      int  := 1000;

BEGIN
    CREATE TEMP TABLE tmp_obj
    (
        id  uuid NOT NULL UNIQUE,
        num serial
    );
    
    INSERT INTO tmp_obj(id)
    SELECT DISTINCT exportfrllodataid
    FROM rds.t_export_frllo_data fed
    WHERE fed.exportfrllodataid = p_exportid;
    
    LOOP
        IF
            NOT EXISTS (SELECT 1 FROM tmp_obj LIMIT 1)
        THEN
            EXIT;
        END IF;
        
        UPDATE rds.t_export_frllo_data fed
        SET frlloid     = NULL,
            frllostatus = NULL,
            frlloerror  = NULL
        WHERE EXISTS(SELECT 1 FROM tmp_obj t WHERE t.id = exportfrllodataid AND t.num <= v_num)
          AND exportfrllo = p_exportid;
        
        DELETE FROM tmp_obj WHERE num <= v_num;
        v_num := v_num + 1000;
    END LOOP;
END;
$$